/*
 * Trim.h
 *
 *  Created on: 23. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef AUTOMATON_TRIM_H_
#define AUTOMATON_TRIM_H_

#include <common/multipleDispatch.hpp>
#include <automaton/Automaton.h>

namespace automaton {

namespace simplify {

class Trim : public std::SingleDispatch<automaton::Automaton, automaton::AutomatonBase> {
public:
	static automaton::Automaton trim( const automaton::Automaton & automaton );

	/**
	 * Removes dead states from FSM. Melichar 2.29
	 */
	template<class T>
	static T trim( const T & fsm );

	static Trim& getInstance() {
		static Trim res;
		return res;
	}
};

} /* namespace simplify */

} /* namespace automaton */

#endif /* AUTOMATON_TRIM_H_ */
