/*
 * UselessStatesRemover.h
 *
 *  Created on: 23. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef USELESS_STATES_REMOVER_H_
#define USELESS_STATES_REMOVER_H_

#include <common/multipleDispatch.hpp>
#include <automaton/Automaton.h>

namespace automaton {

namespace simplify {

class UselessStatesRemover : public std::SingleDispatch<automaton::Automaton, automaton::AutomatonBase> {
public:
	static automaton::Automaton remove( const automaton::Automaton & automaton );

	/**
	 * Removes dead states from FSM. Melichar 2.29
	 */
	template<class T>
	static T remove( const T & automaton );

	static UselessStatesRemover& getInstance() {
		static UselessStatesRemover res;
		return res;
	}
};

} /* namespace simplify */

} /* namespace automaton */

#endif /* USELESS_STATES_REMOVER_H_ */
