/*
 * AutomataUnionEpsilonTransition.h
 *
 *  Created on: 20. 11. 2014
 *	  Author: Tomas Pecka
 */

#ifndef AUTOMATA_UNION_EPSILON_H_
#define AUTOMATA_UNION_EPSILON_H_

#include <common/multipleDispatch.hpp>
#include <automaton/Automaton.h>
#include <automaton/FSM/EpsilonNFA.h>

namespace automaton {

namespace transform {

/**
 * Union two automata.
 *  - For finite automata A1, A2, we create automaton L accepting L(A1) \cup L(A2)
 */
class AutomataUnionEpsilonTransition : public std::PromotingDoubleDispatch<automaton::Automaton, automaton::AutomatonBase> {
public:
	static automaton::Automaton unification(const automaton::Automaton& first, const automaton::Automaton& second);

	static automaton::EpsilonNFA unification(const automaton::EpsilonNFA& first, const automaton::EpsilonNFA& second);
	static automaton::EpsilonNFA unification(const automaton::NFA& first, const automaton::NFA& second);
	static automaton::EpsilonNFA unification(const automaton::DFA& first, const automaton::DFA& second);

	static AutomataUnionEpsilonTransition& getInstance() {
		static AutomataUnionEpsilonTransition res;
		return res;
	}
};

} /* namespace transform */

} /* namespace automaton */

#endif /* AUTOMATA_UNION_EPSILON_H_ */
