/*
 * AutomatonIterationEpsilonTransition.h
 *
 *  Created on: 29. 11. 2014
 *	  Author: Tomas Pecka
 */

#ifndef AUTOMATON_ITERATION_EPSILON_TRANSITION_H_
#define AUTOMATON_ITERATION_EPSILON_TRANSITION_H_

#include <common/multipleDispatch.hpp>
#include <automaton/Automaton.h>
#include <automaton/FSM/EpsilonNFA.h>

namespace automaton {

namespace transform {

/**
 * Iterates language given by automaton
 *  - For finite automaton A1, we create automaton L accepting L(A1)*
 */
class AutomatonIterationEpsilonTransition : public std::SingleDispatch<automaton::Automaton, automaton::AutomatonBase> {
public:
	static automaton::Automaton iteration(const automaton::Automaton& automaton);

	template<class T>
	static automaton::EpsilonNFA iteration(const T& automaton);

	static AutomatonIterationEpsilonTransition& getInstance() {
		static AutomatonIterationEpsilonTransition res;
		return res;
	}
};

} /* namespace transform */

} /* namespace automaton */

#endif /* AUTOMATON_ITERATION_EPSILON_H_ */
