/*
 * Reverse.h
 *
 *  Created on: 7. 11. 2014
 *	  Author: Tomas Pecka
 */

#ifndef REVERSE_H_
#define REVERSE_H_

#include <common/multipleDispatch.hpp>
#include <automaton/Automaton.h>
#include <automaton/common/State.h>

namespace automaton {

namespace transform {

class Reverse : public std::SingleDispatch<automaton::Automaton, automaton::AutomatonBase> {
public:
	static automaton::MultiInitialStateNFA convert(const automaton::DFA& automaton);
	static automaton::MultiInitialStateNFA convert(const automaton::NFA& automaton);
	static automaton::MultiInitialStateNFA convert(const automaton::MultiInitialStateNFA& automaton);

	/**
	 * Creates finite automaton accepting reverse language of given automaton
	 * @param automaton FSM
	 * @return Automaton reverse automaton
	 */
	static automaton::Automaton convert( const automaton::Automaton & automaton );

	static Reverse& getInstance() {
		static Reverse res;
		return res;
	}
};

} /* namespace transform */

} /* namespace automaton */

#endif /* REVERSE_H_ */
